/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Esta ferramenta pode ser usada com o Exec! do MTA Sceo para realizar
   consultas em banco de dados                                         
   Programado por Lucas Priori                                         
   Versao: 1.0                                                         
                                                                       
   Compilar:                                                           
   gcc sceo_mc.c -o sceo_mc -lmysqlclient                              
                                                                       
  ******************************************************************   
  Copyright (C) 2007  Lucas Priori                                     
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<mysql/mysql.h>


#define TAM_buffer 2048
#define VERSAO "1.0"
// -- Dados padroes para  
// conexo com o Banco de 
// dados                  
#define HOST "localhost"
#define DB "sceo"
#define USER "usersceo"
#define PASS "mudar"


/*-----------  Programa Principal  ------------*/
int main(int argc,char *argv[]){
 MYSQL *mysql = NULL;
 MYSQL_RES *myres; 
 MYSQL_ROW myreg;
 char host[128]=HOST;
 char db[128]=DB;
 char user[128]=USER;
 char pass[128]=PASS;
 char *ptr_cmd;
 int existe=0;
 unsigned int cont1=0;


 if(argc==1){
  printf("Sceo Mysql Consult v. %s\n\n",VERSAO);
  printf(" OPES   |   DESCRIO\n");
  printf("   -h         * Para especificar o Host do banco de dados\n");
  printf("              Ex: ./sceo_mysqlconsult -h127.0.0.1 \"SELECT * FROM emails WHERE email='aldair@meudominio.com.br'\"\n");
  printf("   -d         * Para especificar o nome do banco de dados\n");
  printf("              Ex: ./sceo_mysqlconsult -dclientes \"SELECT * FROM emails WHERE email='aldair@meudominio.com.br'\"\n");
  printf("   -u         * Para especificar o usuario do banco de dados\n");
  printf("   -p         * Para especificar a senha do banco de dados\n");
  printf("              Ex: ./sceo_mysqlconsult -umeuusuario -pminhasenha \"SELECT * FROM clientes WHERE email='aldair@meudominio.com.br'\"\n");
  printf("\n");
  printf("Obs: O comando SQL deve ser passado entre aspas\n");
  return 0;
 }
 for(cont1=1;cont1<argc;cont1++){
  if(!strncmp(argv[cont1],"-h",2)){
   // Parametro -h
   strcpy(host,&argv[cont1][2]);
  }else if(!strncmp(argv[cont1],"-d",2)){
   // Parametro -d
   strcpy(db,&argv[cont1][2]);
  }else if(!strncmp(argv[cont1],"-u",2)){
   // Parametro -u
   strcpy(user,&argv[cont1][2]);
  }else if(!strncmp(argv[cont1],"-p",2)){
   // Parametro -p
   strcpy(pass,&argv[cont1][2]);
  }else ptr_cmd=argv[cont1];
 }
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("-ERROR Nao foi possivel iniciar as funes do Mysql\n\n");
  return 255;
 }
 if(mysql_real_connect(mysql,host,user,pass,db,0,NULL,0)){
  // Fazendo a consulta solicitada via shell
  if(!mysql_query(mysql,ptr_cmd)){
   myres=mysql_store_result(mysql);
   if((myreg=mysql_fetch_row(myres))!=NULL)existe=1;
  }
 }else printf("Nao foi possivel conectar no banco de dados\n");
 mysql_close(mysql);
 return existe;
}




